/*-
mapmem: just map some regions int an out.
is a framework for useing the mmap calls.
*/

#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>


#define T_CMD "mapmem" 
#define T_ACCESS T_CMD ": cannot access memory object %s (%s)\n"
#define T_NONAME T_CMD ": must supply filename\n"
#define T_BADARG "use: " T_CMD " file...\n"

main(int argc, char **argv)
{
	int	nerrs=0;
	int	c;
	int	addr = 4*1024;
	int	msize = 64*1024;
	while ((c=getopt(argc, argv, "m:a:")) != EOF) {
		switch (c) {
		case	'm':	msize = strtol(optarg,0,0); break;
		case	'a':	addr = strtol(optarg,0,0); break;
		default:
			fprintf(stderr,T_BADARG);
		}
	}
	if (optind == argc) {
		fprintf(stderr,T_NONAME);
		exit(EXIT_FAILURE);
	}
	for (c=optind; c < argc; c++) {
		char	*s;
		int	fd;
		if ((fd=shm_open(argv[optind],O_RDWR,0)) == -1) {
			fprintf(stderr, T_ACCESS, argv[optind],strerror(errno));
			nerrs++;
			continue;
		}
		if ((s=mmap((void *)addr,msize,PROT_READ|PROT_WRITE,
			MAP_PRIVATE|MAP_FIXED, fd, 0)) == (char*)-1) {
			perror("mmap");
			close(fd);
			continue;
		}
		munmap(s, msize);
		close(fd);
	}
	return nerrs ? EXIT_FAILURE : EXIT_SUCCESS;
}
