/*-
 * mkmem: a program to create memory objects.
 *     mkmem, modelled after mkdir, will make a collection of memory
 *    objects listed as arguments.
 *    by default, the memory objects are 64K in length, this can be
 *    overridden with the "-s" switch.
 */
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>


#define MKMEM "mkmem: "
#define T_CREAT   MKMEM "cannot creat memory object %s (%s)\n"
#define T_SETSIZ  MKMEM "cannot set size of memory object %s (%s)\n"
#define T_NONAME   MKMEM "must supply filename\n"

main(int argc, char **argv)
{
	int	mode=0777;
	int	msize = 65*1024;
	int	nerrs=0;
	int	c;
	int	fd;
	while ((c=getopt(argc, argv, "m:s:")) != EOF) {
		switch (c) {
		case	'm':	mode = strtol(optarg,0,0); break;
		case	's':	msize = strtol(optarg,0,0); break;
		default:
			exit(1);
		}
	}
	if (optind == argc) {
		fprintf(stderr,T_NONAME);
		exit(EXIT_FAILURE);
	}
	for (c=optind; c < argc; c++) {
		if ((fd=shm_open(argv[optind],O_CREAT,mode)) == -1) {
			fprintf(stderr, T_CREAT, argv[optind],strerror(errno));
			nerrs++;
			continue;
		}
		if (ltrunc(fd,msize,SEEK_SET) == -1) {
			fprintf(stderr,T_SETSIZ, argv[optind],strerror(errno));
			shm_unlink(argv[optind]);
			close(fd);
			nerrs++;
			continue;
		}
		close(fd);
	}
	return nerrs ? EXIT_FAILURE : EXIT_SUCCESS;
}
