/*-
 * rmmem: a program to remove memory objects.
 * modeled after the standard utility rm.
 */
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/mman.h>


#define PROGNAME "rmmem: "

#define T_UNLINK  PROGNAME "cannot remove memory object %s (%s)\n"
#define T_NONAME  PROGNAME "must supply filename\n"

main(int argc, char **argv)
{
	int	i;
	int	nerrs = 0;
	if (argc == 1) {
		fprintf(stderr,T_NONAME);
		return EXIT_FAILURE;
	}
	for (i=1; i < argc; i++) {
		if (shm_unlink(argv[i]) == -1) {
			fprintf(stderr,T_UNLINK,argv[i],strerror(errno));
			nerrs++;
		}
	}
	return nerrs ? EXIT_FAILURE : EXIT_SUCCESS;
}
